#include<bits/stdc++.h>
using namespace std;

using big = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int, int>;

const short maxN = 1e4 + 1;
const int maxM = 5e4;
int n, m, q;

struct Edge
{
    short a, b;
};

vector<Edge> edges;
bitset<maxN> start = 0, expen = 0;
int cnt = 0, diff = 0;
vector<short> dsu, sz;

int get(int v)
{
    return (dsu[v] == v ? v : (v = get(dsu[v])));
}

void unite(int u, int v)
{
    u = get(u);
    v = get(v);
    if(u == v) return;
    if(sz[u] > sz[v]) swap(u, v);
    dsu[v] = u;
    sz[u]++;
}

void getComplementSpanningTree()
{
    Edge e;
    for(int i = 0 ; i < m; i++)
    {
        if(!start[i])
        {
            e = edges[i];
            if(get(e.a) != get(e.b))
            {
                expen[i] = 1;
                unite(e.a, e.b);
                cnt++;
                diff++;
                if(cnt == n - 1) break;
            }
        }
    }
    if(cnt < n - 1)
    {
        for(int i = 0 ; i < m; i++)
        {
            if(start[i])
            {
                e = edges[i];
                if(get(e.a) != get(e.b))
                {
                    expen[i] = 1;
                    unite(e.a, e.b);
                    cnt++;
                    if(cnt == n - 1) break;
                }
            }
        }
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    //cin.tie(NULL);

    cin >>n >>m;
    edges.resize(m);
    dsu.resize(n + 1);
    sz.assign(n + 1, 0);
    int v, u;
    for(int i = 0; i < m; i++)
    {
        cin >>v >>u;
        edges[i] = {(short)v, (short)u};
    }
    for(int i = 0; i < n - 1; i++)
    {
        cin >>v;
        v--;
        start[v] = 1;
    }
    for(int i = 0; i < n; i++)
    {
        dsu[i] = i;
    }
    getComplementSpanningTree(); //almost complement
    //for(int i = 0; i < m; i++) cout <<start[i]; cout <<endl;
    //for(int i = 0; i < m; i++) cout <<expen[i]; cout <<endl;
    cout <<diff <<endl;
    cin >>q;
    while(q--)
    {
        cin >>v >>u;
        v--;
        u--;
        start[v] = 1;
        if(expen[v]) diff--;
        start[u] = 0;
        if(expen[u]) diff++;
        cout <<diff <<endl;
    }
}
