//#include <iostream>
#include <vector>
#include <limits>
#include <cstring>
using namespace std;

const int MAXN = 2e6;

struct LinkedElement {
	int PrevIndex;
	int NextIndex;
	int Value;
	int ListIndex;
};

LinkedElement p[MAXN];
int psize;

int listIndexCount = 0;

void init(vector <int> prices) {
	int numNotUsed = prices.size();
	psize = prices.size();
	bool used[prices.size()];
	memset(used, 0, sizeof(used));

	for(int i = 0; i < psize; ++i) {
		p[i].PrevIndex = -1;
		p[i].NextIndex = -1;
		p[i].Value = -1;
		p[i].ListIndex = -1;
	}

	while(numNotUsed > 0) {
		int curr = numeric_limits<int>::max();
		int currIndex = -1;
		//cout << currListIndex << " ";
		for(int i = 0; i < prices.size(); ++i) {
			if(!used[i] && curr > prices[i]) {
				p[i].Value = prices[i];
				p[i].PrevIndex = currIndex;
				p[i].ListIndex = listIndexCount;
				p[currIndex].NextIndex = i;
				curr = prices[i];
				currIndex = i;
				used[i] = true;
				--numNotUsed;
				//cout << p[i].Value << " ";
			}
		}
		//cout << endl;
		++listIndexCount;
	}
	//cout << listIndexCount << endl;
}

int assumption(int day, int price) {
	--day;
	if(price == p[day].Value)
		return listIndexCount;
	
	//cout << p[day].Value << " " << p[day].PrevIndex << " " << p[day].NextIndex << " " << p[day].ListIndex << endl;
	bool canStay = true;
	if(p[day].PrevIndex != -1 && price >= p[p[day].PrevIndex].Value)
		canStay = false;
	if(p[day].NextIndex != -1 && price <= p[p[day].NextIndex].Value)
		canStay = false;
	//cout << canStay << endl;

	//cout << "before" << endl;
	if(canStay) {
		// p[day] is the start of a list
		if(p[day].PrevIndex == -1)
			for(int i = day - 1; i >= 0; --i)
				if(p[i].NextIndex == -1 && p[i].Value > price)
					return listIndexCount - 1;

		// p[day] is the end of list
		if(p[day].NextIndex == -1)
			for(int i = day + 1; i < psize; ++i)
				if(p[i].PrevIndex == -1 && p[i].Value < price)
					return listIndexCount - 1;
		
		// else we see no improvement
		return listIndexCount;
	}
	
	else {
		//cout << "Cannot stay" << endl;
		for(int i = day - 1; i >= 0; --i)
			if(p[i].Value > price)
				if(p[i].NextIndex == -1 || (p[i].NextIndex > day && p[p[i].NextIndex].Value < price) ) {
					//cout << "merge before" << endl;
					//cout << p[i].Value << " " << p[i].PrevIndex << " " << p[i].NextIndex << " " << p[i].ListIndex << endl;
					return listIndexCount;
				}
					
		
		//cout << "after" << endl;
		for(int i = day + 1; i < psize; ++i)
			if(p[i].Value < price)
				if(p[i].PrevIndex == -1 || (p[i].PrevIndex < day && p[p[i].PrevIndex].Value > price) ){
					//cout << "merge after" << endl;
					//cout << p[i].Value << " " << p[i].PrevIndex << " " << p[i].NextIndex << " " << p[i].ListIndex << endl;
					return listIndexCount;
				}

		return listIndexCount + 1;
	}

	return 0;
}