#include <iostream>
#include <vector>
using namespace std;

const int MAXNM = 2e5 + 5;

int n, m;

vector<int> children[MAXNM];
vector<int> queries[MAXNM];

void SetQuery(vector<int>& query, int k, int curr_node) {
	if(k == 0) {
		query.push_back(curr_node);
		return;
	}

	for(int i = 0; i < children[curr_node].size(); ++i)
		SetQuery(query, k - 1, children[curr_node][i]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> n;
	for(int i = 2; i <= n; ++i) {
		int p;
		cin >> p;
		children[p].push_back(i);
	}
		
	cin >> m;
	for(int i = 0; i < m; ++i) {
		int u, k;
		cin >> u >> k;
		SetQuery(queries[i], k, u);
	}

	int l = 0;
	int r = MAXNM;

	for(int i = 2; i <= n; ++i) {
		for(int j = i; j <= n; ++j) {
			if(r - l <= j - i)
				break;
			bool possible = true;
			for(int k = 0; k < m; ++k) {
				bool query_possible = false;
				for(int l = 0; l < queries[k].size(); ++l) {
					if(i <= queries[k][l] && queries[k][l] <= j) {
						query_possible = true;
						break;
					}
				}
				if(!query_possible) {
					possible = false;
					break;
				}
			}
			if(possible) {
				l = i;
				r = j;
			}
		}
	}

	cout << l << " " << r << endl;

	return 0;
}