#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#define fi first
#define se second
using namespace std;

const int MAXN = 10004;
const int MAXM = 50004;

mt19937 rg(879123654);

int n, m;
pair<int, pair<int, int>> edges[MAXM];
int dsu[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> edges[i].se.fi >> edges[i].se.se;
    }
    for (int i = 1; i < n; ++ i)
    {
        int e;
        cin >> e;
        edges[e].fi++;
    }
    for (int i = 1; i <= n; ++ i)
    {
        dsu[i] = i;
    }

    sort(edges + 1, edges + m + 1);
}

int root(int u)
{
    if (dsu[u] == u) return u;
    else return root(dsu[u]);
}

void connect(int u, int v)
{
    int urt = root(u);
    int vrt = root(v);

    if (rg() % 2 == 0) dsu[vrt] = urt;
    else dsu[urt] = vrt;
}

int main()
{
    Init();

    int ans = 0;
    for (int i = 1; i <= m; ++ i)
    {
        int u = edges[i].se.fi;
        int v = edges[i].se.se;
        if (root(u) != root(v))
        {
            ans += edges[i].fi;
            connect(u, v);
        }
    }

    cout << n - 1 - ans << endl;
    return 0;
}
