#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 1e5 + 3;

int n, m;
pair <int, int> edges[maxn];
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i++)
        cin >> edges[i].first >> edges[i].second;
}

int par[maxn], sz[maxn];
int find_root(int ver)
{
    if (ver == par[ver])
        return ver;

    return find_root(par[ver]);
}

stack <int> st;
int cnt_comp;
void merge(int a, int b)
{
    a = find_root(a), b = find_root(b);
    if (a == b)
        return;

    if (sz[a] < sz[b])
        swap(a, b);

    cnt_comp--;
    st.push(b);
    par[b] = a;
    sz[a] += sz[b];
}

vector <int> tr[maxn * 4];
void add(int v, int l, int r, int ll, int rr, int idx)
{
    if (l > rr || r < ll)
        return;

    if (l >= ll && r <= rr)
    {
        tr[v].push_back(idx);
        return;
    }

    int mid = (l + r) / 2;
    add(v * 2, l, mid, ll, rr, idx);
    add(v * 2 + 1, mid + 1, r, ll, rr, idx);
}

void rollback(int prev_sz)
{
    while ((int)st.size() > prev_sz)
    {
        int ver = st.top();
        st.pop();

        sz[par[ver]] -= sz[ver];
        par[ver] = ver;
        cnt_comp++;
    }
}

int ans[maxn];
void f(int v, int l, int r)
{
    int prev_sz = (int)st.size();
    for (auto i: tr[v])
        merge(edges[i].first, edges[i].second);

    if (l == r)
    {
        ans[l] = n - cnt_comp;
        rollback(prev_sz);
        return;
    }

    int mid = (l + r) / 2;
    f(v * 2, l, mid);
    f(v * 2 + 1, mid + 1, r);

    rollback(prev_sz);
}

vector <int> v[maxn];
bool lives[maxn];
void solve()
{
    for (int i = 1; i <= n-1; i++)
    {
        int idx;
        cin >> idx;
        lives[idx] = true;
    }

    int q;
    cin >> q;

    for (int i = 1; i <= q; i++)
    {
        int a, b;
        cin >> a >> b;

        v[a].push_back(i);
        v[b].push_back(i);
    }

    for (int i = 1; i <= m; i++)
    {
        for (int j = 0; j < (int)v[i].size(); j++)
        {
            int prev = (j ? v[i][j-1] : 0);
            if (!lives[i])
                add(1, 0, q, prev, v[i][j] - 1, i);

            lives[i] ^= 1;
        }

        if (!lives[i])
        {
            if (v[i].empty())
            add(1, 0, q, 0, q, i);

            else
                add(1, 0, q, v[i].back(), q, i);
        }
    }

    for (int i = 1; i <= n; i++)
        par[i] = i, sz[i] = 1;

    cnt_comp = n;
    f(1, 0, q);

    for (int i = 0; i <= q; i++)
        cout << ans[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
