#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 2e5 + 3;
const int maxlog = 20;

int n, m;
vector <int> adj[maxn];
void read()
{
    cin >> n;
    for (int i = 2; i <= n; i++)
        {
            int par;
            cin >> par;

            adj[par].push_back(i);
        }

    cin >> m;
}

int idx[maxn];
int leftmost[maxn][maxlog], rightmost[maxn][maxlog];
void dfs(int ver)
{
    for (auto i: adj[ver])
        dfs(i);

    if (adj[ver].empty())
        leftmost[ver][0] = rightmost[ver][0] = 0;

    else
    {
        leftmost[ver][0] = adj[ver][0];
        rightmost[ver][0] = adj[ver].back();
    }
}

void precompute()
{
    dfs(1);
    for (int j = 1; j < maxlog; j++)
        for (int i = 1; i <= n; i++)
    {
        leftmost[i][j] = leftmost[leftmost[i][j-1]][j-1];
        rightmost[i][j] = rightmost[rightmost[i][j-1]][j-1];
    }
}

vector <int> tr[maxn * 4];
void add(int v, int l, int r, int ll, int rr)
{
    if (l == r)
    {
        tr[v].push_back(rr);
        return;
    }

    int mid = (l + r) / 2;
    if (ll <= mid)
        add(v * 2, l, mid, ll, rr);

    else
        add(v * 2 + 1, mid + 1, r, ll, rr);
}

vector <int> merge(vector <int> &a, vector <int> &b)
{
    vector <int> ans;
    int pos_a = 0, pos_b = 0, sz_a = (int)a.size(), sz_b = (int)b.size();
    while (pos_a < sz_a && pos_b < sz_b)
    {
        if (a[pos_a] < b[pos_b])
            ans.push_back(a[pos_a++]);

        else
            ans.push_back(b[pos_b++]);
    }

    while (pos_a < sz_a)
        ans.push_back(a[pos_a++]);

    while (pos_b < sz_b)
        ans.push_back(b[pos_b++]);

    return ans;
}

void build(int v, int l, int r)
{
    if (l == r)
    {
        sort (tr[v].begin(), tr[v].end());
        return;
    }

    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);

    tr[v] = merge(tr[v * 2], tr[v * 2 + 1]);
}

int get(int v, int l, int r, int ll, int rr)
{
    if (l > rr || r < ll)
        return 0;

    if (l >= ll && r <= rr)
    {
        int pos = upper_bound(tr[v].begin(), tr[v].end(), rr) - tr[v].begin();
        return pos;
    }

    int mid = (l + r) / 2;
    return get(v * 2, l, mid, ll, rr) + get(v * 2 + 1, mid + 1, r, ll, rr);
}

int find_k1(int ver, int k)
{
    while (k)
        ver = adj[ver][0], k--;

    return ver;
}

int find_k2(int ver, int k)
{
    while (k)
    ver = adj[ver].back(), k--;

    return ver;
}

void solve()
{
    queue <int> q;
    q.push(1);

    int curr_idx = 0;
    while (!q.empty())
    {
        int ver = q.front();
        q.pop();
        idx[ver] = ++curr_idx;

        for (auto i: adj[ver])
            q.push(i);
    }

    precompute();

    for (int i = 1; i <= m; i++)
    {
        int ver, k;
        cin >> ver >> k;

        /*
        int l = ver, r = ver;
        for (int j = maxlog-1; j >= 0; j--)
            if ((1 << j) <= k)
        {
            k -= (1 << j);
            l = leftmost[l][j];
            r = rightmost[r][j];
        }
        */
        int l = find_k1(ver, k);
        int r = find_k2(ver, k);

        add(1, 1, n, idx[l], idx[r]);
    }

    build(1, 1, n);

    set <int> s;
    s.insert(0);
    s.insert(n+1);

    int r = 1, cnt_bad = m, ans = n, opt_l = 1, opt_r = n;
    for (int i = 1; i <= n; i++)
    {
        if (i != 1)
        {
            auto it = s.find(idx[i-1]);
            cnt_bad += get(1, 1, n, *prev(it) + 1, *next(it) - 1);
            cnt_bad -= get(1, 1, n, *prev(it) + 1, *it - 1);
            cnt_bad -= get(1, 1, n, *it + 1, *next(it) - 1);

            s.erase(it);
        }

        while (r <= n && cnt_bad)
        {
            auto it = s.insert(idx[r++]).first;
            cnt_bad -= get(1, 1, n, *prev(it) + 1, *next(it) - 1);
            cnt_bad += get(1, 1, n, *prev(it) + 1, *it - 1);
            cnt_bad += get(1, 1, n, *it + 1, *next(it) - 1);
        }

        if (cnt_bad)
            break;

        if (r - i < ans)
            ans = r - i, opt_l = i, opt_r = r - 1;
    }

    cout << opt_l << " " << opt_r << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
