#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 2e5 + 3;
const int maxlog = 20;

int n, m;
vector <int> adj[maxn];
void read()
{
    cin >> n;
    for (int i = 2; i <= n; i++)
        {
            int par;
            cin >> par;

            adj[par].push_back(i);
        }

    cin >> m;
}

int idx[maxn];
vector <int> v[maxn];
int tin[maxn], tout[maxn];
int dfs_time;
void dfs(int ver)
{
    tin[ver] = ++dfs_time;
    for (auto i: adj[ver])
        dfs(i);

    tout[ver] = ++dfs_time;
}

vector <int> tr[maxn * 4];
void add(int v, int l, int r, int ll, int rr)
{
    if (l == r)
    {
        tr[v].push_back(rr);
        return;
    }

    int mid = (l + r) / 2;
    if (ll <= mid)
        add(v * 2, l, mid, ll, rr);

    else
        add(v * 2 + 1, mid + 1, r, ll, rr);
}

vector <int> merge(vector <int> &a, vector <int> &b)
{
    vector <int> ans;
    int pos_a = 0, pos_b = 0, sz_a = (int)a.size(), sz_b = (int)b.size();
    while (pos_a < sz_a && pos_b < sz_b)
    {
        if (a[pos_a] < b[pos_b])
            ans.push_back(a[pos_a++]);

        else
            ans.push_back(b[pos_b++]);
    }

    while (pos_a < sz_a)
        ans.push_back(a[pos_a++]);

    while (pos_b < sz_b)
        ans.push_back(b[pos_b++]);

    return ans;
}

void build(int v, int l, int r)
{
    if (l == r)
    {
        sort (tr[v].begin(), tr[v].end());
        return;
    }

    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);

    tr[v] = merge(tr[v * 2], tr[v * 2 + 1]);
}

int get(int v, int l, int r, int ll, int rr)
{
    if (l > rr || r < ll)
        return 0;

    if (l >= ll && r <= rr)
    {
        int pos = upper_bound(tr[v].begin(), tr[v].end(), rr) - tr[v].begin();
        return pos;
    }

    int mid = (l + r) / 2;
    return get(v * 2, l, mid, ll, rr) + get(v * 2 + 1, mid + 1, r, ll, rr);
}

int level[maxn];
void solve()
{
    queue <int> q;
    q.push(1);
    level[1] = 1;

    int curr_idx = 0;
    while (!q.empty())
    {
        int ver = q.front();
        q.pop();
        idx[ver] = ++curr_idx;

        for (auto i: adj[ver])
        {
            q.push(i);
            level[i] = level[ver] + 1;
            v[level[i]].push_back(i);
        }
    }

    dfs(1);

    for (int i = 1; i <= m; i++)
    {
        int ver, k;
        cin >> ver >> k;

        int lvl = level[ver] + k;
        int low = 0, high = (int)v[lvl].size() - 1;
        while (low < high)
        {
            int mid = (low + high) / 2;
            if (tin[v[lvl][mid]] < tin[ver])
                low = mid + 1;

            else
                high = mid;
        }

        int l = low;
        low = 0, high = (int)v[lvl].size() - 1;
        while (low < high)
        {
            int mid = (low + high + 1) / 2;
            if (tin[v[lvl][mid]] > tout[ver])
                high = mid - 1;

            else
                low = mid;
        }

        int r = low;
        add(1, 1, n, idx[v[lvl][l]], idx[v[lvl][r]]);
    }

    build(1, 1, n);

    set <int> s;
    s.insert(0);
    s.insert(n+1);

    int r = 1, cnt_bad = m, ans = n, opt_l = 1, opt_r = n;
    for (int i = 1; i <= n; i++)
    {
        if (i != 1)
        {
            auto it = s.find(idx[i-1]);
            cnt_bad += get(1, 1, n, *prev(it) + 1, *next(it) - 1);
            cnt_bad -= get(1, 1, n, *prev(it) + 1, *it - 1);
            cnt_bad -= get(1, 1, n, *it + 1, *next(it) - 1);

            s.erase(it);
        }

        while (r <= n && cnt_bad)
        {
            auto it = s.insert(idx[r++]).first;
            cnt_bad -= get(1, 1, n, *prev(it) + 1, *next(it) - 1);
            cnt_bad += get(1, 1, n, *prev(it) + 1, *it - 1);
            cnt_bad += get(1, 1, n, *it + 1, *next(it) - 1);
        }

        if (cnt_bad)
            break;

        if (r - i < ans)
            ans = r - i, opt_l = i, opt_r = r - 1;
    }

    cout << opt_l << " " << opt_r << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
