#include<bits/stdc++.h>
using namespace std;
vector<multiset<int>> forward_lookup;
vector<multiset<int>> reverse_lookup;
vector<int> pr;

void build_lookups(vector<int>& prices) {
    forward_lookup.resize(prices.size());
    reverse_lookup.resize(prices.size());
    multiset<int> nums;
    for(int i = 0; i < prices.size(); i++) {
        if(nums.size() == 0) {
            nums.insert(prices[i]);
            forward_lookup[i] = nums;
            continue;
        }
        auto bound = nums.upper_bound(prices[i]);
        if(bound == nums.end()) {
            nums.insert(prices[i]);
        }
        else {
            nums.erase(bound);
            nums.insert(prices[i]);
        }
        forward_lookup[i] = nums;
    }
    nums.clear();
    for(int i = prices.size()-1; i>=0; i--) {
        if(nums.size()==0) {
            nums.insert(-prices[i]);
            reverse_lookup[i] = nums;
            continue;
        }
        auto bound = nums.upper_bound(-prices[i]);
        if(bound == nums.end()) {
            nums.insert(-prices[i]);
        }
        else {
            nums.erase(bound);
            nums.insert(-prices[i]);
        }
        reverse_lookup[i] = nums;
    }
}

void init(vector<int> prices) {
    pr = prices;
    build_lookups(prices);

}

int assumption(int day, int price) {
    day--;
    multiset<int> before, after;
    if(day > 0) {
        before = forward_lookup[day-1];
    }
    if(day < pr.size() - 1) {
        after = reverse_lookup[day+1];
    }
    auto bound = before.upper_bound(price);
    if(bound == before.end()) {
        before.insert(price);
    }
    else {
        before.erase(bound);
        before.insert(price);
    }
    int res = 0;
    while((!before.empty()) && (!after.empty())) {
        auto forward_max = --before.end();
        auto backward_max = --after.end();
        if(*forward_max > -*backward_max) {
            before.erase(forward_max);
            after.erase(backward_max);
            res++;
        }
        else {
            res++;
            after.erase(backward_max);
        }
    }
    return res + before.size() + after.size();
}
