#include<bits/stdc++.h>
using namespace std;
vector<multiset<short>> forward_lookup;
vector<multiset<short>> reverse_lookup;
vector<int> pr;

void build_lookups(vector<int>& prices) {
    forward_lookup.resize(prices.size());
    reverse_lookup.resize(prices.size());
    multiset<short> nums;
    for(int i = 0; i < prices.size(); i++) {
        if(nums.size() == 0) {
            nums.insert(prices[i]);
            forward_lookup[i] = nums;
            continue;
        }
        auto bound = nums.upper_bound(prices[i]);
        if(bound == nums.end()) {
            nums.insert(prices[i]);
        }
        else {
            nums.erase(bound);
            nums.insert(prices[i]);
        }
        forward_lookup[i] = nums;
    }
    nums.clear();
    for(int i = prices.size()-1; i>=0; i--) {
        if(nums.size()==0) {
            nums.insert(-prices[i]);
            reverse_lookup[i] = nums;
            continue;
        }
        auto bound = nums.upper_bound(-prices[i]);
        if(bound == nums.end()) {
            nums.insert(-prices[i]);
        }
        else {
            nums.erase(bound);
            nums.insert(-prices[i]);
        }
        reverse_lookup[i] = nums;
    }
    /*cout<<"f:";
    for(auto sett : forward_lookup) {
        for(int x : sett) {cout<<x<<" ";}
        cout<<" | ";
    }
    cout<<endl;
    cout<<"r:";
    for(auto sett : reverse_lookup) {
        for(int x : sett) {cout<<x<<" ";}
        cout<<" | ";
    }
    cout<<endl;*/
}

void init(vector<int> prices) {
    pr = prices;
    build_lookups(prices);

}

int assumption(int day, int price) {
    if(pr.size()==1) {
        return 1;
    }

    day--;
    multiset<short> before, after;
    if(day > 0) {
        before = forward_lookup[day-1];
    }
    if(day < pr.size() - 1) {
        after = reverse_lookup[day+1];
    }
    auto bound = before.upper_bound(price);
    if(bound == before.end()) {
        before.insert(price);
    }
    else {
        before.erase(bound);
        before.insert(price);
    }
    int res = 0;
    /*cout<<"before:"<<endl;
    for(int x : before) {
        cout<<x<<" ";
    }
    cout<<endl;
    cout<<"after:"<<endl;
    for(int x : after) {
        cout<<x<<" ";
    }
    cout<<endl;*/
    while((!before.empty()) && (!after.empty())) {
        auto forward_max = --before.end();
        auto backward_max = after.begin();
        if(*forward_max > -*backward_max) {
            //cout<<"matched"<< *forward_max <<" and" << -*backward_max<<endl;
            before.erase(forward_max);
            after.erase(backward_max);
            res++;
        }
        else {
            res++;
            after.erase(backward_max);
        }
    }
    return res + before.size() + after.size();
}
