#include<bits/stdc++.h>
using namespace std;
vector<map<short, short>> forward_lookup;
vector<map<short, short>> reverse_lookup;
vector<int> pr;
map<short, short> t(multiset<short> s) {
    map<short, short> res;
    for(short ss : s) {
        res[ss]++;
    }
    return res;
}

void build_lookups(vector<int>& prices) {
    forward_lookup.resize(prices.size());
    reverse_lookup.resize(prices.size());
    multiset<short> nums;
    for(int i = 0; i < prices.size(); i++) {
        if(nums.size() == 0) {
            nums.insert(prices[i]);
            forward_lookup[i] = t(nums);
            continue;
        }
        auto bound = nums.upper_bound(prices[i]);
        if(bound == nums.end()) {
            nums.insert(prices[i]);
        }
        else {
            nums.erase(bound);
            nums.insert(prices[i]);
        }
        forward_lookup[i] = t(nums);
    }
    nums.clear();
    for(int i = prices.size()-1; i>=0; i--) {
        if(nums.size()==0) {
            nums.insert(-prices[i]);
            reverse_lookup[i] = t(nums);
            continue;
        }
        auto bound = nums.upper_bound(-prices[i]);
        if(bound == nums.end()) {
            nums.insert(-prices[i]);
        }
        else {
            nums.erase(bound);
            nums.insert(-prices[i]);
        }
        reverse_lookup[i] = t(nums);
    }
    /*cout<<"f:";
    for(auto sett : forward_lookup) {
        for(int x : sett) {cout<<x<<" ";}
        cout<<" | ";
    }
    cout<<endl;
    cout<<"r:";
    for(auto sett : reverse_lookup) {
        for(int x : sett) {cout<<x<<" ";}
        cout<<" | ";
    }
    cout<<endl;*/
}

void init(vector<int> prices) {
    pr = prices;
    build_lookups(prices);

}

int assumption(int day, int price) {
    if(pr.size()==1) {
        return 1;
    }

    day--;
    map<short, short> before, after;
    if(day > 0) {
        before = forward_lookup[day-1];
    }
    if(day < pr.size() - 1) {
        after = reverse_lookup[day+1];
    }
    auto bound = before.upper_bound(price);
    if(bound == before.end()) {
        before[price]++;
    }
    else {
        before[(*bound).first]--;
        if(before[(*bound).first] == 0) {
            before.erase(bound);
        }
        before[price]++;
    }
    int res = 0;
    /*cout<<"before:"<<endl;
    for(int x : before) {
        cout<<x<<" ";
    }
    cout<<endl;
    cout<<"after:"<<endl;
    for(int x : after) {
        cout<<x<<" ";
    }
    cout<<endl;*/
    while((!before.empty()) && (!after.empty())) {
        pair<short,short> forward_max = *(--before.end());
        pair<short,short> backward_max = *after.begin();
        if(forward_max.first > -backward_max.first) {
            //cout<<"matched"<< *forward_max <<" and" << -*backward_max<<endl;
            int cnt = min(forward_max.second, backward_max.second);
            before[forward_max.first]-=cnt;
            after[backward_max.first]-=cnt;
            if(before[forward_max.first] == 0) {before.erase(forward_max.first);}
            if(after[backward_max.first] == 0) {after.erase(backward_max.first);}
            res+= cnt;
        }
        else {
            res+= after[backward_max.first];
            after.erase(backward_max.first);
        }
    }
    for(auto x : before) {
        res += x.second;
    }
    for(auto x : after) {
        res += x.second;
    }

    return res;
}
