#include <algorithm>
#include <iostream>
#include <assert.h>
#include <vector>
#include <set>

#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

vector <int> prices;

void init (vector <int> _prices)
{
    prices = _prices;
}

int numCnt[1005];
vector <int> num2SeqsInds[1005];

int findInd(vector <int> &seqs, int x, vector <bool> *used = nullptr)
{
    int bestInd = -1;
    for(int i = 0;i<seqs.size();i++)
    {
        if(used!=nullptr && (*used)[i]==true) continue;

        if(seqs[i]>x)
        {
            if(bestInd==-1 || seqs[bestInd]>seqs[i])
                bestInd = i;
        }
    }

    return bestInd;
}

void add(vector <int> &seqs, int x)
{
    int bestInd = findInd(seqs, x);

    if(bestInd!=-1) seqs[bestInd] = x;
    else seqs.push_back(x);
}

void makeSeqs(vector <int> &seqs, int l, int r)
{
    for(int i = l;i<=r;i++)
        add(seqs, prices[i]);
}

int mergeSeqs(vector <int> &seqs1, vector <int> &seqs2)
{
    /*
    cout << "seqs1:";
    for(int x: seqs1) cout << " " << x;
    cout << '\n';

    cout << "seqs2:";
    for(int x: seqs2) cout << " " << x;
    cout << '\n';
    */

    vector <bool> used(seqs1.size(), false);
    sort(seqs2.begin(), seqs2.end());

    int placed = 0;
    for(int x: seqs2)
    {
        int ind = findInd(seqs1, x, &used);

        if(ind!=-1)
        {
            placed++;
            used[ind] = true;
        }
        else
        {
            break;
        }
    }

    return seqs1.size() + seqs2.size() - placed;
}

int assumption (int day, int price)
{
    int _oldPrice = prices[day-1];
    prices[day-1] = price;

    vector <int> seqs1, seqs2;
    makeSeqs(seqs1, 0, day-1);
    makeSeqs(seqs2, day, prices.size()-1);

    int ans = mergeSeqs(seqs1, seqs2);

    prices[day-1] = _oldPrice;
    return ans;
}

/*
7
6 8 5 7 4 6 9
*/
