#include <algorithm>
#include <iostream>
#include <assert.h>
#include <vector>
#include <set>

#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

vector <int> prices;

void init (vector <int> _prices)
{
    prices = _prices;
}

int numCnt[1005];
vector <int> num2SeqsInds[1005];

int findInd(vector <int> &seqs, int x, bool inv, vector <bool> *used = nullptr)
{
    int bestInd = -1;
    for(int i = 0;i<seqs.size();i++)
    {
        if(used!=nullptr && (*used)[i]==true) continue;

        if(inv==false)
        {
            if(seqs[i]>x)
            {
                if(bestInd==-1 || seqs[bestInd]>seqs[i])
                    bestInd = i;
            }
        }
        else
        {
            if(seqs[i]<x)
            {
                if(bestInd==-1 || seqs[bestInd]<seqs[i])
                    bestInd = i;
            }
        }
    }

    return bestInd;
}

void add(vector <int> &seqs, int x, bool inv)
{
    int bestInd = findInd(seqs, x, inv);

    if(bestInd!=-1) seqs[bestInd] = x;
    else seqs.push_back(x);
}

void makeSeqs(vector <int> &seqs, int l, int r, bool inv)
{
    if(inv==false)
    {
        for(int i = l;i<=r;i++)
            add(seqs, prices[i], inv);
    }
    else
    {
        for(int i = r;i>=l;i--)
            add(seqs, prices[i], inv);
    }

}

bool check(vector <int> &seqs1, vector <int> &seqs2, int len)
{
    for(int i = 0;i<len;i++)
    {
        if(!(seqs1[seqs1.size()-(len-i)] > seqs2[i]))
            return false;
    }

    return true;
}

int mergeSeqs(vector <int> &seqs1, vector <int> &seqs2)
{
    /*
    cout << "seqs1:";
    for(int x: seqs1) cout << " " << x;
    cout << '\n';

    cout << "seqs2:";
    for(int x: seqs2) cout << " " << x;
    cout << '\n';
    */

    sort(seqs1.begin(), seqs1.end());
    sort(seqs2.begin(), seqs2.end());

    int placed = 0;
    int l = 1, r = min(seqs1.size(), seqs2.size()), mid;
    while(l+1<r)
    {
        mid = (l+r)/2;

        if(check(seqs1, seqs2, mid)==true) l = mid;
        else r = mid - 1;
    }

    if(check(seqs1, seqs2, r)==true) placed = r;
    else if(check(seqs1, seqs2, l)==true) placed = l;

    return seqs1.size() + seqs2.size() - placed;
}

int assumption (int day, int price)
{
    int _oldPrice = prices[day-1];
    prices[day-1] = price;

    vector <int> seqs1, seqs2;
    makeSeqs(seqs1, 0, day-1, false);
    makeSeqs(seqs2, day, prices.size()-1, true);

    int ans = mergeSeqs(seqs1, seqs2);

    prices[day-1] = _oldPrice;
    return ans;
}

/*
7
6 8 5 7 4 6 9
*/
