#include <algorithm>
#include <iostream>
#include <assert.h>
#include <vector>
#include <set>

#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

vector <int> prices;

void init (vector <int> _prices)
{
    prices = _prices;
}

int findInd(vector <int> &seqs, int x, bool inv, vector <bool> *used = nullptr)
{
    int bestInd = -1;
    for(int i = 0;i<seqs.size();i++)
    {
        if(used!=nullptr && (*used)[i]==true) continue;

        if(inv==false)
        {
            if(seqs[i]>x)
            {
                if(bestInd==-1 || seqs[bestInd]>seqs[i])
                    bestInd = i;
            }
        }
        else
        {
            if(seqs[i]<x)
            {
                if(bestInd==-1 || seqs[bestInd]<seqs[i])
                    bestInd = i;
            }
        }
    }

    return bestInd;
}

void add(vector <int> &seqs, int x, bool inv)
{
    int bestInd = findInd(seqs, x, inv);

    if(bestInd!=-1) seqs[bestInd] = x;
    else seqs.push_back(x);
}

int seqs1Sz, seqs2Sz;
int seqs1[20005], seqs2[20005];

void makeSeqs(int seqs[], int &seqsSz, int l, int r, bool inv)
{
    if(inv==false)
    {
        multiset <int> ms;
        for(int i = l;i<=r;i++)
        {
            auto it = ms.upper_bound(prices[i]);

            if(it==ms.end()) ms.insert(prices[i]);
            else
            {
                ms.erase(it);
                ms.insert(prices[i]);
            }
        }

        seqsSz = 0;
        for(int x: ms)
        {
            seqs[seqsSz] = x;
            seqsSz++;
        }
    }
    else
    {
        multiset <int> ms;
        for(int i = r;i>=l;i--)
        {
            auto it = ms.lower_bound(prices[i]);

            if(it!=ms.begin())
            {
                it--;
                if(*it < prices[i])
                {
                    ms.erase(it);
                }
            }

            ms.insert(prices[i]);
        }

        seqsSz = 0;
        for(int x: ms)
        {
            seqs[seqsSz] = x;
            seqsSz++;
        }
    }

}

bool check(int len)
{
    for(int i = 0;i<len;i++)
    {
        if(!(seqs1[seqs1Sz-(len-i)] > seqs2[i]))
            return false;
    }

    return true;
}

int mergeSeqs()
{
    int placed = 0;
    int l = 1, r = min(seqs1Sz, seqs2Sz), mid;
    while(l+1<r)
    {
        mid = (l+r)/2;

        if(check(mid)==true) l = mid;
        else r = mid - 1;
    }

    if(check(r)==true) placed = r;
    else if(check(l)==true) placed = l;

    return seqs1Sz + seqs2Sz - placed;
}

int assumption (int day, int price)
{
    int _oldPrice = prices[day-1];
    prices[day-1] = price;

    makeSeqs(seqs1, seqs1Sz, 0, day-1, false);
    makeSeqs(seqs2, seqs2Sz, day, prices.size()-1, true);

    int ans = mergeSeqs();

    prices[day-1] = _oldPrice;
    return ans;
}

/*
7
6 8 5 7 4 6 9
*/
