#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1e5 + 5;

struct DSU
{
    int parent[MAXN];

    DSU(){}
    DSU(int n)
    {
        for(int x = 1;x<=n;x++)
        {
            this->parent[x] = x;
        }
    }

    int Find(int x)
    {
        if(parent[x]==x) return parent[x];

        parent[x] = Find(parent[x]);
        return parent[x];
    }

    bool Union(int u, int v)
    {
        u = Find(u);
        v = Find(v);
        if(u==v) return false;

        parent[v] = u;
        return true;
    }
};

int main()
{
    int n, m;
    cin >> n >> m;

    vector <pair <bool, pair <int, int>>> edges;
    for(int i = 0;i<m;i++)
    {
        int u, v;
        cin >> u >> v;

        edges.push_back({true, {u, v}});
    }

    for(int i = 0;i<n-1;i++)
    {
        int ind;
        cin >> ind;

        int u = edges[ind-1].second.first;
        int v = edges[ind-1].second.second;
        edges[ind-1].first = false;
    }

    DSU *T = new DSU(n);
    sort(edges.begin(), edges.end(), greater <pair <bool, pair <int, int>>>());

    int ans = 0;
    for(auto &item: edges)
    {
        pair <int, int> e = item.second;
        if(T->Union(e.first, e.second)==true)
        {
            ans += item.first;
            //cout << e.first << " " << e.second << '\n';
        }
    }

    cout << ans << '\n';
}
/*
4 6
1 2
1 3
1 4
2 3
2 4
3 4
1 2 3
*/
