#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>
#include <queue>
#include <set>

using namespace std;

const int MAXN = 2e5 + 5;

int n;
int parent[MAXN];
vector <int> children[MAXN];

int depth[MAXN];
vector <int> level2Nodes[MAXN];
pair <int, int> subtreeInds[MAXN];

vector <int> options[MAXN];
vector <int> optionsInv[MAXN];

int dfsInit(int x, int level, int id)
{
    //cout << x << " -> " << id << '\n';

    depth[x] = level;
    level2Nodes[level].push_back(x);

    int maxId = id;
    subtreeInds[x].first = id;

    for(int y: children[x])
    {
        maxId = max(maxId, dfsInit(y, level+1, maxId+1));
    }

    subtreeInds[x].second = maxId;
    return maxId;
}

vector <pair <int, int>> requirements;
void readRequirements()
{
    set <pair <int, int>> used;

    int Q;
    cin >> Q;

    for(int i = 0;i<Q;i++)
    {
        int u, k;
        cin >> u >> k;

        if(used.count({u, k})==false)
        {
            used.insert({u, k});
            requirements.push_back({u, k});
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int x = 2;x<=n;x++)
    {
        cin >> parent[x];
        children[parent[x]].push_back(x);
    }

    dfsInit(1, 1, 1);
    for(int x = 1;x<=n;x++)
    {
        //cout << x << " -> " << subtreeInds[x].first << " " << subtreeInds[x].second << '\n';
    }

    readRequirements();
    for(int i = 0;i<requirements.size();i++)
    {
        int u = requirements[i].first;
        int k = requirements[i].second;

        if(k!=1)
        {
            for(int x: level2Nodes[depth[u]+k])
            {
                if(subtreeInds[u].first<=subtreeInds[x].first
                   && subtreeInds[x].first<=subtreeInds[u].second)
                {
                    options[i].push_back(x);
                    optionsInv[x].push_back(i);
                }
            }
        }
        else
        {
            for(int x: children[u])
            {
                options[i].push_back(x);
                optionsInv[x].push_back(i);
            }
        }

        sort(options[i].begin(), options[i].end(), greater <int>());
    }

    /*
    for(int i = 0;i<Q;i++)
    {
        cout << i << ":";
        for(int x: options[i])
            cout << " " << x;
        cout << '\n';
    }
    */

    pair <int, int> ans = {0, MAXN};
    multiset <int> active;

    for(int i = 0;i<requirements.size();i++)
        active.insert(options[i].back());

    for(int x = 1;x<=n;x++)
    {
        int maxNode = *prev(active.end());
        if(maxNode-x+1 < ans.second-ans.first+1)
        {
            ans = {x, maxNode};
        }

        bool fail = false;

        active.erase(x);
        for(int i: optionsInv[x])
        {
            options[i].pop_back();

            if(options[i].size()==0)
            {
                fail = true;
            }
            else
            {
                active.insert(options[i].back());
            }
        }

        if(fail==true)
        {
            break;
        }
    }

    cout << ans.first << " " << ans.second << '\n';
}
