#include<bits/stdc++.h>
using namespace std;

struct Treap
{
    struct Node
    {
        int key,pr,pos;
        Node *l,*r;

        Node(){}
        Node(int _key,int _pos)
        {
            key = _key;
            pos = _pos;
            pr = rand();
            l = r = NULL;
        }

        int right_()
        {
            int m = key;
            if(r)
                m = r->right_();

            return m;
        }

        int left_()
        {
            int m = key;
            if(l)
                m = l->left_();

            return m;
        }

        void print()
        {
            if(l)l->print();
            cout<<key<<" ";
            if(r)r->print();
        }

    };

    Node *node;
    Treap(){node = NULL;}

    void Split(Node *T, Node *&L, Node *&R, int pos)
    {
        if(!T)
        {
            L = R = NULL;
            return ;
        }

        if(T->pos > pos)
        {
            R = T;
            Split(T->l,L,R->l,pos);
        }
        else
        {
            L = T;
            Split(T->r,L->r,R,pos);
        }
    }

    void Merge(Node *&T, Node *L, Node *R)
    {
        if(!L)
        {
            T = R;
            return;
        }
        if(!R)
        {
            T = L;
            return;
        }

        if(L->pr > R->pr)
        {
            T = L;
            Merge(T->r,L->r,R);
        }
        else
        {
            T = R;
            Merge(T->l,L,R->l);
        }
    }

    bool Insert(int key,int pos)
    {
        Node *L,*R;
        Node *M = new Node(key,pos);

        Split(node,L,R,pos);
        if(L)
        {
            int ml = L->right_();
            if(ml <= key)goto label1;
        }

        int mr;
        if(R)
        {
            mr = R->left_();
            if(mr >= key)goto label1;
        }

        Merge(L,L,M);
        Merge(node,L,R);
        return true;

        label1:

        Merge(node,L,R);
        return false;
    }

    void Delete(int pos)
    {
        Node *L,*M,*R;
        Split(node,L,R,pos);
        Split(L,L,M,pos-1);
        Merge(node,L,R);
    }
};

int const maxn = 2*1e4;

Treap T[maxn];
vector<int>pr;
bool used[maxn];
int idx[maxn];
int br;

void init (std::vector <int> prices)
{
    int i,sz = prices.size();

    pr.push_back(-1);
    for(i=0; i<sz; i++)
        pr.push_back(prices[i]);

    for(i=1; i<=sz; i++)
    {
        int t = pr[i];

        int j;
        bool lamp = false;
        for(j=0; j<br; j++)
            if(T[j].Insert(t,i))
            {
                idx[i] = j;
                lamp = true;
                break;
            }

        if(!lamp)
        {
            T[br].Insert(t,i);
            idx[i] = br;
            br++;
        }

    }
    return;
}

int assumption (int day, int price)
{
    int prv = pr[day];
    int sz = br + 1;
    pr[day] = price;

    T[idx[day]].Delete(day);

    int k,i;
    for(i=0; i<sz; i++)
        if(T[i].Insert(price,day))
        {
            k = i;
            break;
        }

    int ans = 0;
    for(i=0; i<sz; i++)
        if(T[i].node)
        {

            ans++;
        }

    T[k].Delete(day);
    T[idx[day]].Insert(prv,day);

    pr[day] = prv;
    return ans;
}
