#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

struct Entity {
    int value;
    int index;
    int currencyID;

    Entity(int value, int index, int currencyID) {
        this->value = value;
        this->index = index;
        this->currencyID = currencyID;
    }

    bool operator <(const Entity &rhs) const {
        if (this->value == rhs.value) {
            return (this->index < rhs.index);
        }

        return (this->value < rhs.value);
    }
};

int n;
vector<int> prices;
vector<int> currencyID;
vector<int> numInCurrency;
int numCurrencies;

void init(vector<int> prices) {
    n = prices.size();
    ::prices = prices;

    currencyID.resize(n);

    int cnt = 0;
    set<Entity> last;
    last.emplace(prices[0], 0, cnt);
    currencyID[0] = 0;
    numInCurrency.emplace_back(1);

    for (int i = 1; i < n; i++) {
        auto to = last.upper_bound(Entity(prices[i], 1e9, -1));

        if (to == last.end()) {
            cnt++;
            last.emplace(prices[i], i, cnt);
            currencyID[i] = cnt;
            numInCurrency.emplace_back(1);
        } else {
            Entity next = Entity(prices[i], i, to->currencyID);
            last.erase(to);
            last.emplace(next);
            currencyID[i] = to->currencyID;
            numInCurrency[to->currencyID]++;
        }
    }

    numCurrencies = cnt;

        /*
    for (int i = 0; i < n; i++) {
        cout << currencyID[i] << ' ';
    }
    cout << endl;

    for (int i : numInCurrency) {
        cout << i << ' ';
    }
    cout << endl;
    */
}

int assumption(int day, int price) {
    day--;

    int answer = numCurrencies + 1;
    if (numInCurrency[currencyID[day]] > 1) {
        answer++;
    }

    for (int i = 0; i < numCurrencies; i++) {
        if (i == currencyID[day] && numInCurrency[currencyID[day]] == 1) {
            continue;
        }

        int l = -1;
        for (int j = day - 1; j >= 0; j--) {
            if (currencyID[j] == i) {
                l = j;
                break;
            }
        }

        if (l != -1 && prices[l] <= price) {
            continue;
        }

        int r = -1;
        for (int j = day + 1; j < n; j++) {
            if (currencyID[j] == i) {
                r = j;
                break;
            }
        }

        if (r != -1 && price <= prices[r]) {
            continue;
        }

        return (answer - 1);
    }

    return answer;
}

/*
6 8 5 7 4 6 9
*/
