#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

struct Edge {
    int from;
    int to;
    int cost;

    Edge(int from, int to) {
        this->from = from;
        this->to = to;
        this->cost = 1;
    }

    bool operator <(const Edge &rhs) const {
        return (this->cost > rhs.cost);
    }
};

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;
vector<Edge> edges;

void read() {
    cin >> n >> m;

    edges.reserve(m);
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        edges.emplace_back(from, to);
    }

    for (int i = 0; i < n - 1; i++) {
        int pos;
        cin >> pos;

        edges[pos - 1].cost = 0;
    }
}

vector<int> par, sz;

int root(int node) {
    if (par[node] == -1) {
        return node;
    }

    return (par[node] = root(par[node]));
}

void unite(int u, int v) {
    u = root(u);
    v = root(v);

    if (u != v) {
        if (sz[u] < sz[v]) {
            swap(u, v);
        }

        par[v] = u;
        sz[u] += sz[v];
    }
}

void solve() {
    sort(edges.begin(), edges.end());

    par.resize(n + 1, -1);
    sz.resize(n + 1, 1);
    int answer = 0;
    for (auto &i : edges) {
        if (root(i.from) != root(i.to)) {
            answer += i.cost;
            unite(i.from, i.to);
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
