#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, m;
vector<pair<int, int>> edges;
set<pair<int, int>> goodEdges;

void read() {
    cin >> n >> m;

    edges.reserve(m);
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        edges.emplace_back(from, to);
        goodEdges.emplace(edges.back());
    }

    for (int i = 0; i < n - 1; i++) {
        int pos;
        cin >> pos;

        goodEdges.erase(edges[pos - 1]);
    }
}

vector<int> par, sz;

int root(int node) {
    if (par[node] == -1) {
        return node;
    }

    return (par[node] = root(par[node]));
}

void unite(int u, int v) {
    u = root(u);
    v = root(v);

    if (u != v) {
        if (sz[u] < sz[v]) {
            swap(u, v);
        }

        par[v] = u;
        sz[u] += sz[v];
    }
}

void query() {
    fill(par.begin(), par.end(), -1);
    fill(sz.begin(), sz.end(), 1);

    int answer = 0;
    for (auto &i : goodEdges) {
        if (root(i.first) != root(i.second)) {
            answer++;
            unite(i.first, i.second);
        }
    }

    cout << answer << endl;
}

void solve() {
    par.resize(n + 1);
    sz.resize(n + 1);

    query();

    int q;
    cin >> q;

    while (q--) {
        int i, j;
        cin >> i >> j;

        goodEdges.erase(edges[i - 1]);
        goodEdges.emplace(edges[j - 1]);

        query();
    }
}

int main() {
    setIO();

    read();

    solve();
}
