#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<vector<int>> children;

void read() {
    cin >> n;

    children.resize(n + 1);
    for (int i = 2; i <= n; i++) {
        int par;
        cin >> par;

        children[par].emplace_back(i);
    }
}

int m;
vector<vector<int>> nodes;

void bfs(int root, int level) {
    queue<pair<int, int>> q;

    q.emplace(root, 0);

    while (!q.empty()) {
        pair<int, int> now = q.front();
        q.pop();

        if (now.second == level) {
            nodes.back().emplace_back(now.first);
            continue;
        }

        for (int child : children[now.first]) {
            q.emplace(child, now.second + 1);
        }
    }
}

bool check(int l, int r) {
    for (int i = 0; i < m; i++) {
        bool ok = false;
        for (int j : nodes[i]) {
            if (j >= l && j <= r) {
                ok = true;
                break;
            }
        }

        if (!ok) {
            return false;
        }
    }

    return true;
}

void solve() {
    cin >> m;

    for (int i = 0; i < m; i++) {
        int u, k;
        cin >> u >> k;

        nodes.emplace_back();
        bfs(u, k);
    }

    for (int len = 1; len <= n; len++) {
        for (int from = 1; from <= n - len + 1; from++) {
            int to = from + len - 1;
            if (check(from, to)) {
                cout << from << ' ' << to << endl;
                return;
            }
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}
