#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<vector<int>> children;
vector<int> par;

void read() {
    cin >> n;

    children.resize(n + 1);
    par.resize(n + 1, -1);
    for (int i = 2; i <= n; i++) {
        cin >> par[i];

        children[par[i]].emplace_back(i);
    }
}

int m;
vector<vector<int>> nodes;

void bfs(int root, int level) {
    queue<pair<int, int>> q;

    q.emplace(root, 0);

    while (!q.empty()) {
        pair<int, int> now = q.front();
        q.pop();

        if (now.second == level) {
            nodes.back().emplace_back(now.first);
            continue;
        }

        for (int child : children[now.first]) {
            q.emplace(child, now.second + 1);
        }
    }
}

bool check(int l, int r) {
    for (int i = 0; i < m; i++) {
        bool ok = false;
        for (int j : nodes[i]) {
            if (j >= l && j <= r) {
                ok = true;
                break;
            }
        }

        if (!ok) {
            return false;
        }
    }

    return true;
}

bool isTree() {
    for (int i = 2; i <= n; i++) {
        if (par[i] != i - 1) {
            return false;
        }
    }

    return true;
}

void solveTree() {
    cin >> m;

    int l = 1e9, r = -1e9;
    for (int i = 0; i < m; i++) {
        int u, k;
        cin >> u >> k;

        l = min(l, u + k);
        r = max(r, u + k);
    }

    cout << l << ' ' << r << endl;
}

bool eval(int len) {
    for (int from = 1; from <= n - len + 1; from++) {
        int to = from + len - 1;

        if (check(from, to)) {
            return true;
        }
    }

    return false;
}

void solve() {
    if (isTree()) {
        solveTree();
        return;
    }

    cin >> m;

    for (int i = 0; i < m; i++) {
        int u, k;
        cin >> u >> k;

        nodes.emplace_back();
        bfs(u, k);
    }

    int pwdLen = 1;
    while ((pwdLen << 1) <= n) {
        pwdLen <<= 1;
    }

    while (pwdLen >= 1) {
        if (eval(pwdLen)) {
            pwdLen >>= 1;
        } else {
            pwdLen <<= 1;
            break;
        }
    }

    if (pwdLen == 0) {
        pwdLen = 1;
    }

    int low = 1, high = pwdLen;
    int len = n;

    while (low <= high) {
        int mid = (low + high) >> 1;

        if (eval(mid)) {
            len = mid;
            high = mid - 1;
        } else {
            low = mid + 1;
        }
    }

    for (int from = 1; from <= n - len + 1; from++) {
        int to = from + len - 1;
        if (check(from, to)) {
            cout << from << ' ' << to << endl;
            break;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}
